#ifndef CALC_H
#define CALC_H


int get_term_num(TokenString &, int );

double *ResolveID(TokenString &Param, int p, double **, FieldObj *Ca, 
                  BufferArray *Bufs, class KineticObj *KO);
char   *ResolvePtr(double *ptr, FieldObj *Ca, BufferArray *Bufs, KineticObj *KO);

//*************************************************************************************

struct TermStruct
{
  char   type;
  double val;
  double *ptr;
};

//*************************************************************************************

class ExpressionObj
{

 public:

  struct TermStruct *term_array;
  int    term_num;

  ExpressionObj(int n = 0)  { term_array = new TermStruct[term_num = n]; }

  ExpressionObj(const ExpressionObj &EO) { 
    term_array = new TermStruct[term_num = EO.term_num];
    *this = EO;
  }

  void operator=(const ExpressionObj &EO) {
    for (int i = 0; i < term_num; i++) term_array[i] = EO.term_array[i]; }

  ~ExpressionObj()    { delete [] term_array; }
  void   Optimize();
  double Evaluate();
  void print(FILE *f = stderr, FieldObj *Ca=0, BufferArray *Bufs=0, KineticObj *KO=0);
  void print2(FILE *f = stderr, FieldObj *Ca=0, BufferArray *Bufs=0, KineticObj *KO=0);

  friend class KinExpression;
};

//*************************************************************************************

class KinExpression : public ExpressionObj
{
 public:

  KinExpression(TokenString &, int, double *, FieldObj * = 0, BufferArray * = 0,
                class KineticObj * = 0);

  KinExpression() : ExpressionObj(0) { } 
};

//*************************************************************************************

#endif
