#ifndef TABLE_H
#define TABLE_H

#define TABLE_LABEL  "table"

//**************************************************************************

class TableObj
{
  public:

  char *file_name, *ID;
  FILE *file;

  double *xarray, *yarray;
  double value, valueOld;

  long    num, index, indexOld;

  /*
  TableObj() { file_name = ID = 0; xarray = yarray = 0; }

  //  TableObj(const TableObj& TO)  { copy(TO); }

  const TableObj& operator=(const TableObj& TO)  {
    if (&TO != this) { destroy(); copy(TO); }
    return *this;
  }

  void copy(const TableObj& TO);
  */

  void saveState() { indexOld = index; valueOld = value; }
  void recoverState() { index = indexOld; value = valueOld; }

  TableObj(const char *fname, const char *id = "TABLE");

  ~TableObj()  { destroy(); }

  void destroy() { delete [] ID; delete [] xarray; delete [] yarray; }

  double Evaluate(double);
};

//**************************************************************************

class TableArray
{
 public:

  TableObj **array;
  int      table_num;

  /*
  TableArray() { array = 0; table_num = 0; };

  TableArray(int n) : 
    table_num(n), array(new TableObj *[n]) { }

  TableArray(const TableArray& TA)  { copy(TA); }

  const TableArray& operator=(const TableArray& TA)  {
    if (&TA != this) { destroy(); copy(TA); }
    return *this;
  }

  void copy(const TableArray& TA);
  */

  TableArray(TokenString &Param);

  ~TableArray()  {  destroy(); } 


  void Evaluate(double t)  {
    for (int i = 0; i < table_num; i++) array[i]->Evaluate(t);
  }

  void destroy() { for (int i = 0; i < table_num; i++) delete array[i];
                   delete [] array; }

  void saveState() { for (int i = 0; i < table_num; i++) array[i]->saveState(); }
  void recoverState() { for (int i = 0; i < table_num; i++) array[i]->recoverState(); }

};

//**************************************************************************

#endif
